From 9108a966aa146487815f639f653cd0401e2849c5 Mon Sep 17 00:00:00 2001
From: Walter Doekes <walter+github@wjd.nu>
Date: Sat, 5 Sep 2015 17:21:25 +0200
Subject: [PATCH 04/15] Add Asterisk 11 support.

Author: me, in August 2013.
---
 app.c         |   3 +-
 ast_compat.h  |  56 ++++++++++++++++++++++
 at_response.c |   9 ++--
 chan_dongle.c |   5 +-
 chan_dongle.h |   4 ++
 channel.c     | 148 ++++++++++++++++++++++++++++++++++------------------------
 cli.c         |   6 ++-
 manager.c     |   4 ++
 8 files changed, 166 insertions(+), 69 deletions(-)
 create mode 100644 ast_compat.h

diff --git a/app.c b/app.c
index c0965ff..a46fc8d 100644
--- a/app.c
+++ b/app.c
@@ -18,7 +18,8 @@
 #include <asterisk/app.h>	/* AST_DECLARE_APP_ARGS() ... */
 #include <asterisk/pbx.h>	/* pbx_builtin_setvar_helper() */
 #include <asterisk/module.h>	/* ast_register_application2() ast_unregister_application() */
-#include <asterisk/version.h>	/* ASTERISK_VERSION_NUM */
+
+#include "ast_compat.h"		/* asterisk compatibility fixes */
 
 #include "app.h"		/* app_register() app_unregister() */
 #include "chan_dongle.h"	/* struct pvt */
diff --git a/ast_compat.h b/ast_compat.h
new file mode 100644
index 0000000..c22b75e
--- /dev/null
+++ b/ast_compat.h
@@ -0,0 +1,56 @@
+#ifndef CHAN_DONGLE_AST_COMPAT_H_INCLUDED
+#define CHAN_DONGLE_AST_COMPAT_H_INCLUDED
+
+#ifndef ASTERISK_VERSION_NUM
+#error ASTERISK_VERSION_NUM is not set. Please re-run configure, \
+	prefixed like this: CPPFLAGS=-DASTERISK_VERSION_NUM=100501 \
+	./configure (where 100501 is asterisk version 10.5.1).
+#endif
+
+#include <asterisk/channel.h>
+
+/* Asterisk 11+ channel opaqification */
+#if ASTERISK_VERSION_NUM < 110000
+
+/* channel->name */
+static inline const char *ast_channel_name(const struct ast_channel *chan) { return chan->name; }
+
+/* channel->_state / channel->state */
+static inline enum ast_channel_state ast_channel_state(const struct ast_channel *chan) { return chan->_state; }
+
+/* channel->fdno */
+static inline int ast_channel_fdno(const struct ast_channel *chan) { return chan->fdno; }
+
+/* channel->tech */
+static inline const struct ast_channel_tech *ast_channel_tech(const struct ast_channel *chan) { return chan->tech; }
+static inline void ast_channel_tech_set(struct ast_channel *chan, const struct ast_channel_tech *value) { chan->tech = value; }
+
+static inline void *ast_channel_tech_pvt(const struct ast_channel *chan) { return chan->tech_pvt; }
+static inline void ast_channel_tech_pvt_set(struct ast_channel *chan, void *value) { chan->tech_pvt = value; }
+
+/* channel->rings */
+static inline int ast_channel_rings(const struct ast_channel *chan) { return chan->rings; }
+static inline void ast_channel_rings_set(struct ast_channel *chan, int value) { chan->rings = value; }
+
+/* ast_string_field_set(channel, language, ...) */
+static inline void ast_channel_language_set(struct ast_channel *chan, const char *value) { ast_string_field_set(chan, language, value); }
+
+/* channel->connected */
+static inline struct ast_party_connected_line *ast_channel_connected(struct ast_channel *chan) { return &chan->connected; }
+
+/* channel->linkedid */
+static inline const char *ast_channel_linkedid(const struct ast_channel *chan) { return chan->linkedid; }
+
+/* channel->hangupcause */
+static inline void ast_channel_hangupcause_set(struct ast_channel *chan, int value) { chan->hangupcause = value; }
+
+#if ASTERISK_VERSION_NUM >= 100000
+/* channel->*format* */
+static inline struct ast_format_cap *ast_channel_nativeformats(const struct ast_channel *chan) { return chan->nativeformats; }
+static inline struct ast_format ast_channel_readformat(const struct ast_channel *chan) { return chan->readformat; }
+static inline struct ast_format ast_channel_writeformat(const struct ast_channel *chan) { return chan->writeformat; }
+#endif
+
+#endif
+
+#endif /* CHAN_DONGLE_AST_COMPAT_H_INCLUDED */
diff --git a/at_response.c b/at_response.c
index e66be46..ad3e056 100644
--- a/at_response.c
+++ b/at_response.c
@@ -16,6 +16,8 @@
 #include <asterisk/logger.h>			/* ast_debug() */
 #include <asterisk/pbx.h>			/* ast_pbx_start() */
 
+#include "ast_compat.h"				/* asterisk compatibility fixes */
+
 #include "at_response.h"
 #include "mutils.h"				/* STRLEN() */
 #include "at_queue.h"
@@ -851,14 +853,14 @@ static int start_pbx(struct pvt* pvt, const char * number, int call_idx, call_st
 
 		return -1;
 	}
-	cpvt = channel->tech_pvt;
+	cpvt = ast_channel_tech_pvt(channel);
 // FIXME: not execute if channel_new() failed
 	CPVT_SET_FLAGS(cpvt, CALL_FLAG_NEED_HANGUP);
 
 	// ast_pbx_start() usually failed if asterisk.conf minmemfree set too low, try drop buffer cache sync && echo 3 > /proc/sys/vm/drop_caches
 	if (ast_pbx_start (channel))
 	{
-		channel->tech_pvt = NULL;
+		ast_channel_tech_pvt_set(channel, NULL);
 		cpvt_free(cpvt);
 
 		ast_hangup (channel);
@@ -920,8 +922,7 @@ static int at_response_clcc (struct pvt* pvt, char* str)
 								if(cpvt->channel)
 								{
 									/* FIXME: unprotected channel access */
-									cpvt->channel->rings += pvt->rings;
-									pvt->rings = 0;
+									ast_channel_rings_set(cpvt->channel, ast_channel_rings(cpvt->channel) + pvt->rings);
 								}
 							}
 							if(state != cpvt->state)
diff --git a/chan_dongle.c b/chan_dongle.c
index 48dc1d3..dba5a49 100644
--- a/chan_dongle.c
+++ b/chan_dongle.c
@@ -39,7 +39,6 @@
 #include <asterisk.h>
 ASTERISK_FILE_VERSION(__FILE__, "$Rev: " PACKAGE_REVISION " $")
 
-#include <asterisk/version.h>
 #include <asterisk/stringfields.h>	/* AST_DECLARE_STRING_FIELDS for asterisk/manager.h */
 #include <asterisk/manager.h>
 #include <asterisk/dsp.h>
@@ -53,6 +52,8 @@ ASTERISK_FILE_VERSION(__FILE__, "$Rev: " PACKAGE_REVISION " $")
 #include <fcntl.h>			/* O_RDWR O_NOCTTY */
 #include <signal.h>			/* SIGURG */
 
+#include "ast_compat.h"			/* asterisk compatibility fixes */
+
 #include "chan_dongle.h"
 #include "at_response.h"		/* at_res_t */
 #include "at_queue.h"			/* struct at_queue_task_cmd at_queue_head_cmd() */
@@ -68,8 +69,10 @@ ASTERISK_FILE_VERSION(__FILE__, "$Rev: " PACKAGE_REVISION " $")
 
 EXPORT_DEF const char * const dev_state_strs[4] = { "stop", "restart", "remove", "start" };
 EXPORT_DEF public_state_t * gpublic;
+#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
 EXPORT_DEF struct ast_format chan_dongle_format;
 EXPORT_DEF struct ast_format_cap * chan_dongle_format_cap;
+#endif
 
 
 static int public_state_init(struct public_state * state);
diff --git a/chan_dongle.h b/chan_dongle.h
index 4783e5e..b3adab7 100644
--- a/chan_dongle.h
+++ b/chan_dongle.h
@@ -16,6 +16,8 @@
 #include <asterisk/lock.h>
 #include <asterisk/linkedlists.h>
 
+#include <ast_compat.h>
+
 #include "mixbuffer.h"				/* struct mixbuffer */
 //#include "ringbuffer.h"				/* struct ringbuffer */
 #include "cpvt.h"				/* struct cpvt */
@@ -36,9 +38,11 @@ INLINE_DECL const char * dev_state2str_msg(dev_state_t state)
 	return enum2str(state, states, ITEMS_OF(states));
 }
 
+#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
 /* Only linear is allowed */
 EXPORT_DECL struct ast_format chan_dongle_format;
 EXPORT_DECL struct ast_format_cap * chan_dongle_format_cap;
+#endif
 
 typedef enum {
 	RESTATE_TIME_NOW	= 0,
diff --git a/channel.c b/channel.c
index ea75931..73e4033 100644
--- a/channel.c
+++ b/channel.c
@@ -12,6 +12,10 @@
 #include <config.h>
 #endif /* HAVE_CONFIG_H */
 
+#ifndef ASTERISK_VERSION_NUM
+#error ASTERISK_VERSION_NUM is not set, please supply -D ASTERISK_VERSION_NUM=100501 for version 10.5.1
+#endif
+
 #include <asterisk.h>
 #include <asterisk/dsp.h>			/* ast_dsp_digitreset() */
 #include <asterisk/pbx.h>			/* pbx_builtin_setvar_helper() */
@@ -20,7 +24,8 @@
 #include <asterisk/musiconhold.h>		/* ast_moh_start() ast_moh_stop() */
 #include <asterisk/lock.h>			/* AST_MUTEX_DEFINE_STATIC */
 #include <asterisk/timing.h>			/* ast_timer_fd() ast_timer_set_rate() ast_timer_ack() */
-#include <asterisk/version.h>			/* ASTERISK_VERSION_NUM */
+
+#include "ast_compat.h"
 
 #include "channel.h"
 #include "chan_dongle.h"
@@ -29,6 +34,7 @@
 #include "at_queue.h"				/* write_all() TODO: move out */
 #include "manager.h"				/* manager_event_call_state_change() */
 
+
 static char silence_frame[FRAME_SIZE];
 
 #/* */
@@ -90,25 +96,23 @@ EXPORT_DEF int channels_loop(struct pvt * pvt, const struct ast_channel * reques
 	/* FIXME: requestor may be just proxy/masquerade for real channel */
 	//	use ast_bridged_channel(chan) ?
 	//	use requestor->tech->get_base_channel() ?
-	if(requestor && requestor->tech == &channel_tech && requestor->tech_pvt && ((struct cpvt*)requestor->tech_pvt)->pvt == pvt)
+	struct cpvt *cpvt = ast_channel_tech_pvt(requestor);
+	if(requestor && ast_channel_tech(requestor) == &channel_tech && cpvt && cpvt->pvt == pvt)
 		return 1;
 	return 0;
 }
 
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-
+// TODO: simplify by move common code to functions
+/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
+#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+static struct ast_channel * channel_request (attribute_unused const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, const char *data, int *cause)
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10+ */
 static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel *requestor, void * data, int * cause)
-
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-//   TODO: simplify by move common code to functions
 static struct ast_channel * channel_request (attribute_unused const char * type, format_t format, const struct ast_channel * requestor, void * data, int * cause)
-
-#else /* 1.8- */
-/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
-
+#else /* #if ASTERISK_VERSION_NUM < 10800 */
 static struct ast_channel * channel_request (attribute_unused const char * type, int format, void * data, int * cause)
-
-#endif
+#endif /* #if ASTERISK_VERSION_NUM < 10800 */
 {
 #if ASTERISK_VERSION_NUM >= 10800 && ASTERISK_VERSION_NUM < 100000 /* 1.8+ .. 10- */
 	format_t oldformat;
@@ -133,11 +137,11 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 #if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
 	if (!ast_format_cap_iscompatible(cap, &chan_dongle_format))
 #else
-	oldformat = format;
-	format &= AST_FORMAT_SLINEAR;
-	if (!format)
+        oldformat = format;
+        format &= AST_FORMAT_SLINEAR;
+        if (!format)
 #endif
-	{
+        {
 #if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
 		char buf[255];
 		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_getformatname_multiple (buf, 255, cap));
@@ -182,9 +186,13 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 }
 
 #/* */
+#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+static int channel_call (struct ast_channel* channel, const char *dest, attribute_unused int timeout)
+#else
 static int channel_call (struct ast_channel* channel, char* dest, attribute_unused int timeout)
+#endif
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 	char* dest_dev;
 	const char* dest_num;
@@ -193,7 +201,7 @@ static int channel_call (struct ast_channel* channel, char* dest, attribute_unus
 
 	if(!cpvt || cpvt->channel != channel || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return -1;
 	}
 	pvt = cpvt->pvt;
@@ -203,9 +211,9 @@ static int channel_call (struct ast_channel* channel, char* dest, attribute_unus
 	if(parse_dial_string(dest_dev, &dest_num, &opts))
 		return -1;
 
-	if ((channel->_state != AST_STATE_DOWN) && (channel->_state != AST_STATE_RESERVED))
+	if ((ast_channel_state(channel) != AST_STATE_DOWN) && (ast_channel_state(channel) != AST_STATE_RESERVED))
 	{
-		ast_log (LOG_WARNING, "channel_call called on %s, neither down nor reserved\n", channel->name);
+		ast_log (LOG_WARNING, "channel_call called on %s, neither down nor reserved\n", ast_channel_name(channel));
 		return -1;
 	}
 
@@ -220,14 +228,14 @@ static int channel_call (struct ast_channel* channel, char* dest, attribute_unus
 	}
 	CPVT_SET_FLAGS(cpvt, opts);
 
-	ast_debug (1, "[%s] Calling %s on %s\n", PVT_ID(pvt), dest, channel->name);
+	ast_debug (1, "[%s] Calling %s on %s\n", PVT_ID(pvt), dest, ast_channel_name(channel));
 
 	if (CONF_SHARED(pvt, usecallingpres))
 	{
 		if (CONF_SHARED(pvt, callingpres) < 0)
 		{
 #if ASTERISK_VERSION_NUM >= 10800
-			clir = channel->connected.id.number.presentation;
+			clir = ast_channel_connected(channel)->id.number.presentation;
 #else
 			clir = channel->cid.cid_pres;
 #endif
@@ -339,7 +347,7 @@ static void activate_call(struct cpvt* cpvt)
 #/* we has 2 case of call this function, when local side want terminate call and when called for cleanup after remote side alreay terminate call, CEND received and cpvt destroyed */
 static int channel_hangup (struct ast_channel* channel)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 
 	/* its possible call with channel w/o tech_pvt */
@@ -368,7 +376,7 @@ static int channel_hangup (struct ast_channel* channel)
 	}
 
 	/* drop channel -> cpvt reference */
-	channel->tech_pvt = NULL;
+	ast_channel_tech_pvt_set(channel, NULL);
 
 	ast_module_unref (self_module());
 	ast_setstate (channel, AST_STATE_DOWN);
@@ -379,12 +387,12 @@ static int channel_hangup (struct ast_channel* channel)
 #/* */
 static int channel_answer (struct ast_channel* channel)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 
 	if(!cpvt || cpvt->channel != channel || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return 0;
 	}
 	pvt = cpvt->pvt;
@@ -408,13 +416,13 @@ static int channel_answer (struct ast_channel* channel)
 #/* */
 static int channel_digit_begin (struct ast_channel* channel, char digit)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 	int rv;
 
 	if(!cpvt || cpvt->channel != channel || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return -1;
 	}
 	pvt = cpvt->pvt;
@@ -582,20 +590,21 @@ static void write_conference(struct pvt * pvt, const char * buffer, size_t lengt
 
 }
 
+
 #if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-#define subclass_integer	subclass.integer
+#define subclass_integer       subclass.integer
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-#define subclass_codec		subclass.codec
-#define subclass_integer	subclass.integer
+#define subclass_codec         subclass.codec
+#define subclass_integer       subclass.integer
 #else /* 1.8- */
-#define subclass_codec		subclass
-#define subclass_integer	subclass
+#define subclass_codec         subclass
+#define subclass_integer       subclass
 #endif
 
 #/* */
 static struct ast_frame* channel_read (struct ast_channel* channel)
 {
-	struct cpvt*		cpvt = channel->tech_pvt;
+	struct cpvt*		cpvt = ast_channel_tech_pvt(channel);
 	struct pvt*		pvt;
 	struct ast_frame*	f = &ast_null_frame;
 	ssize_t			res;
@@ -619,7 +628,7 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 		goto e_return;
 	}
 
-	if (pvt->a_timer && channel->fdno == 1)
+	if (pvt->a_timer && ast_channel_fdno(channel) == 1)
 	{
 		ast_timer_ack (pvt->a_timer, 1);
 		timing_write (pvt);
@@ -744,7 +753,7 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 #/* */
 static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 	size_t count;
 	int gains[2];
@@ -760,7 +769,7 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 
 	if(!cpvt || cpvt->channel != channel || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return 0;
 	}
 
@@ -785,14 +794,16 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 	if(CPVT_TEST_FLAG(cpvt, CALL_FLAG_MULTIPARTY) && !CPVT_TEST_FLAG(cpvt, CALL_FLAG_BRIDGE_CHECK))
 	{
 		struct ast_channel* bridged = ast_bridged_channel(channel);
+		struct cpvt *tmp_cpvt;
 
 		CPVT_SET_FLAGS(cpvt, CALL_FLAG_BRIDGE_CHECK);
 
-		if(bridged && bridged->tech == &channel_tech && bridged->tech_pvt && ((struct cpvt*)bridged->tech_pvt)->pvt == pvt)
+		tmp_cpvt = ast_channel_tech_pvt(bridged);
+		if(bridged && ast_channel_tech(bridged) == &channel_tech && tmp_cpvt && tmp_cpvt->pvt == pvt)
 		{
 			CPVT_SET_FLAGS(cpvt, CALL_FLAG_BRIDGE_LOOP);
-			CPVT_SET_FLAGS((struct cpvt*)bridged->tech_pvt, CALL_FLAG_BRIDGE_LOOP);
-			ast_log (LOG_WARNING, "[%s] Bridged channels %s and %s working on same device, discard writes to avoid voice loop\n", PVT_ID(pvt), channel->name, bridged->name);
+			CPVT_SET_FLAGS((struct cpvt*)ast_channel_tech_pvt(bridged), CALL_FLAG_BRIDGE_LOOP);
+			ast_log(LOG_WARNING, "[%s] Bridged channels %s and %s working on same device, discard writes to avoid voice loop\n", PVT_ID(pvt), ast_channel_name(channel), ast_channel_name(bridged));
 			goto e_return;
 		}
 	}
@@ -915,12 +926,12 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 #/* */
 static int channel_fixup (struct ast_channel* oldchannel, struct ast_channel* newchannel)
 {
-	struct cpvt * cpvt = newchannel->tech_pvt;
+	struct cpvt * cpvt = ast_channel_tech_pvt(newchannel);
 	struct pvt* pvt;
 
 	if (!cpvt || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", newchannel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(newchannel));
 		return -1;
 	}
 	pvt = cpvt->pvt;
@@ -936,7 +947,11 @@ static int channel_fixup (struct ast_channel* oldchannel, struct ast_channel* ne
 }
 
 #/* FIXME: must modify in conjuction with state on call not whole device? */
+#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+static int channel_devicestate (const char *data)
+#else
 static int channel_devicestate (void* data)
+#endif
 {
 	char*	device;
 	struct pvt*	pvt;
@@ -971,7 +986,7 @@ static int channel_indicate (struct ast_channel* channel, int condition, const v
 {
 	int res = 0;
 
-	ast_debug (1, "[%s] Requested indication %d\n", channel->name, condition);
+	ast_debug (1, "[%s] Requested indication %d\n", ast_channel_name(channel), condition);
 
 	switch (condition)
 	{
@@ -1000,7 +1015,7 @@ static int channel_indicate (struct ast_channel* channel, int condition, const v
 			break;
 
 		default:
-			ast_log (LOG_WARNING, "[%s] Don't know how to indicate condition %d\n", channel->name, condition);
+			ast_log (LOG_WARNING, "[%s] Don't know how to indicate condition %d\n", ast_channel_name(channel), condition);
 			res = -1;
 			break;
 	}
@@ -1112,7 +1127,7 @@ EXPORT_DEF void change_channel_state(struct cpvt * cpvt, unsigned newstate, int
 
 
 					/* drop channel -> cpvt reference */
-					channel->tech_pvt = NULL;
+					ast_channel_tech_pvt_set(channel, NULL);
 					cpvt_free(cpvt);
 					if (queue_hangup (channel, cause))
 					{
@@ -1139,7 +1154,7 @@ static void set_channel_vars(struct pvt* pvt, struct ast_channel* channel)
 		{ "DONGLENUMBER", pvt->subscriber_number },
 	};
 
-	ast_string_field_set (channel, language, CONF_SHARED(pvt, language));
+	ast_channel_language_set(channel, CONF_SHARED(pvt, language));
 
 	for(idx = 0; idx < ITEMS_OF(dev_vars); ++idx)
 		pbx_builtin_setvar_helper (channel, dev_vars[idx].name, dev_vars[idx].value);
@@ -1156,7 +1171,7 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 	if (cpvt)
 	{
 #if ASTERISK_VERSION_NUM >= 10800
-		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), requestor ? requestor->linkedid : NULL, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
+		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), requestor ? ast_channel_linkedid(requestor) : NULL, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
 #else
 		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
 #endif
@@ -1165,12 +1180,18 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 			cpvt->channel = channel;
 			pvt->channel_instanse++;
 
-			channel->tech_pvt	= cpvt;
-			channel->tech		= &channel_tech;
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-			ast_format_cap_add(channel->nativeformats, &chan_dongle_format);
-			ast_format_copy(&channel->writeformat, &chan_dongle_format);
-			ast_format_copy(&channel->readformat, &chan_dongle_format);
+			ast_channel_tech_pvt_set(channel, cpvt);
+			ast_channel_tech_set(channel, &channel_tech);
+
+
+#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+			ast_format_set(ast_channel_readformat(channel), AST_FORMAT_SLINEAR, 0);
+			ast_format_set(ast_channel_writeformat(channel), AST_FORMAT_SLINEAR, 0);
+			ast_format_cap_set(ast_channel_nativeformats(channel), ast_channel_writeformat(channel));
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+			ast_format_set(&channel->readformat, AST_FORMAT_SLINEAR, 0);
+			ast_format_set(&channel->writeformat, AST_FORMAT_SLINEAR, 0);
+			ast_format_cap_set(channel->nativeformats, &channel->writeformat);
 #else /* 10- */
 			channel->nativeformats	= AST_FORMAT_SLINEAR;
 			channel->writeformat	= AST_FORMAT_SLINEAR;
@@ -1179,7 +1200,7 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 
 			if (ast_state == AST_STATE_RING)
 			{
-				channel->rings = 1;
+				ast_channel_rings_set(channel, 1);
 			}
 
 			set_channel_vars(pvt, channel);
@@ -1246,8 +1267,9 @@ EXPORT_DEF int queue_hangup(struct ast_channel* channel, int hangupcause)
 	int rv = 0;
 	if(channel)
 	{
-		if (hangupcause != 0)
-			channel->hangupcause = hangupcause;
+		if (hangupcause != 0) {
+			ast_channel_hangupcause_set(channel, hangupcause);
+		}
 
 		rv = ast_queue_hangup (channel);
 	}
@@ -1267,7 +1289,7 @@ EXPORT_DEF void start_local_channel (struct pvt* pvt, const char* exten, const c
 	channel = ast_request ("Local", chan_dongle_format_cap, NULL, channel_name, &cause);
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
 	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, NULL, channel_name, &cause);
-#else /* 1.8- */
+#else
 	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, channel_name, &cause);
 #endif
 	if (channel)
@@ -1294,13 +1316,13 @@ EXPORT_DEF void start_local_channel (struct pvt* pvt, const char* exten, const c
 #/* */
 static int channel_func_read(struct ast_channel* channel, attribute_unused const char* function, char* data, char* buf, size_t len)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
 	int ret = 0;
 
 	if(!cpvt || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return -1;
 	}
 	pvt = cpvt->pvt;
@@ -1351,15 +1373,17 @@ static int channel_func_read(struct ast_channel* channel, attribute_unused const
 #/* */
 static int channel_func_write(struct ast_channel* channel, const char* function, char* data, const char* value)
 {
-	struct cpvt* cpvt = channel->tech_pvt;
+	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
+	struct pvt* pvt;
 	call_state_t newstate, oldstate;
 	int ret = 0;
 
 	if(!cpvt || !cpvt->pvt)
 	{
-		ast_log (LOG_WARNING, "call on unreferenced %s\n", channel->name);
+		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return -1;
 	}
+	pvt = cpvt->pvt;
 
 	if (!strcasecmp(data, "callstate"))
 	{
@@ -1431,7 +1455,7 @@ EXPORT_DEF struct ast_channel_tech channel_tech =
 	.type			= "Dongle",
 	.description		= MODULE_DESCRIPTION,
 #if ASTERISK_VERSION_NUM < 100000 /* 10- */
-	.capabilities		= AST_FORMAT_SLINEAR,
+	.capabilities           = AST_FORMAT_SLINEAR,
 #endif
 	.requester		= channel_request,
 	.call			= channel_call,
diff --git a/cli.c b/cli.c
index d0b1918..4c25562 100644
--- a/cli.c
+++ b/cli.c
@@ -12,10 +12,14 @@
 #include <config.h>
 #endif /* HAVE_CONFIG_H */
 
+#ifndef ASTERISK_VERSION_NUM
+#error ASTERISK_VERSION_NUM is not set, please supply \
+	-D ASTERISK_VERSION_NUM=100501 for version 10.5.1
+#endif
+
 #include <asterisk.h>
 #include <asterisk/cli.h>			/* struct ast_cli_entry; struct ast_cli_args */
 #include <asterisk/callerid.h>			/* ast_describe_caller_presentation() */
-#include <asterisk/version.h>			/* ASTERISK_VERSION_NUM */
 
 #include "cli.h"
 #include "chan_dongle.h"			/* devices */
diff --git a/manager.c b/manager.c
index ceda3a2..4f9e962 100644
--- a/manager.c
+++ b/manager.c
@@ -733,7 +733,11 @@ EXPORT_DEF void manager_register()
 	unsigned i;
 	for(i = 0; i < ITEMS_OF(dcm); i++)
 	{
+#if ASTERISK_VERSION_NUM >= 110000
+		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, NULL, dcm[i].brief, dcm[i].desc);
+#else
 		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, dcm[i].brief, dcm[i].desc);
+#endif
 	}
 }
 

